#!/usr/bin/perl

#┌─────────────────────────────────
#│ Smart Board Type-G v2.6 : check.cgi - 2023/09/14
#│ copyright (c) TRANSFORM, Since 2012
#│ https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 外部ファイル取込み
require './init.cgi';
my %cf = set_init();

print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<title>Check Mode</title>
</head>
<body>
<b>Check Mode: [ $cf{version} ]</b>
<ul>
<li>Perlバージョン : $]
EOM

# ディレクトリ
my %dir = (
	$cf{datadir}         => 'データディレクトリ',
	$cf{imgdir}          => '画像ディレクトリ',
	$cf{diaryimgdir}     => 'ダイアリー画像ディレクトリ',
	$cf{cmnurl}          => '共用ディレクトリ',
	$cf{faceurl}         => '顔アイコンファイルディレクトリ',
	$cf{weatherurl}      => '天気アイコンファイルディレクトリ',
	$cf{iconurl}         => 'アイコンファイルディレクトリ',
	$cf{sesdir}          => 'セッションファイルディレクトリ',
	"$cf{datadir}/past"  => '過去ログディレクトリ',
	"$cf{adminsesdir}"   => '管理パスワードセッションディレクトリ',
	"$cf{datadir}/pwd"   => '管理パスワードディレクトリ',
	);
for ( keys %dir ) {
	if (-d $_) {
		print "<li>$dir{$_}パス : OK\n";
		next if ($_ eq $cf{datadir});
		
		if (-r $_ && -w $_ && -x $_) {
			print "<li>$dir{$_}パーミッション : OK\n";
		} else {
			print "<li>$dir{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$dir{$_}パス : NG\n";
	}
}

# データファイル
my %log = (
	"$cf{datadir}/log.cgi"       => '記事データファイル',
	"$cf{datadir}/diarylog.cgi"  => 'ダイアリーデータファイル',
	"$cf{datadir}/iconfile.cgi"  => 'アイコンファイル',
	"$cf{datadir}/reslog.cgi"    => 'コメントファイル',
	"$cf{datadir}/memdata.cgi"   => '会員ファイル',
	"$cf{datadir}/addno.dat"     => '参照ボタン数データ',
	"$cf{datadir}/count.dat"     => 'カウントファイル',
	"$cf{datadir}/exchange.dat"  => 'モード切り替えデータファイル',
	"$cf{datadir}/pastno.dat"    => '過去ログデータ番号ファイル',
	"$cf{datadir}/pass.dat"      => '管理パスワードデータファイル',
	"$cf{datadir}/res_cnt.dat"   => 'コメント数INDEXファイル',
	"$cf{datadir}/resno.dat"     => 'コメント数データファイル',
	"$cf{datadir}/side.dat"      => 'お知らせデータファイル',
	);
for ( keys %log ) {
	if (-f $_) {
		print "<li>$log{$_}パス : OK\n";
		if (-r $_ && -w $_) {
			print "<li>$log{$_}パーミッション : OK\n";
		} else {
			print "<li>$log{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$log{$_}パス : NG\n";
	}
}

# テンプレート
for (qw(album archv article bbs calen calendar change change_pass com_edit com_form com_pwdform com_read comment d-icon_pwd d-iconreg  diary diary_admin diary_edit diary_editpass diary_topic dico_edit dico_gate dico_msg edit enter error expound find flag_color form ico_edit ico_gate ico_msg icon icon_pwd iconote iconreg mon_cal msg msg_diary note pass_form past pwd read res weather_mark)) {
	if (-e "$cf{tmpldir}/$_.html") {
		print "<li>テンプレート( $_.html ) : OK\n";
	} else {
		print "<li>テンプレート( $_.html ) : NG\n";
	}
}

# Image-Magick動作確認
eval { require Image::Magick; };
if ($@) {
	print "<li>Image-Magick動作: NG\n";
} else {
	print "<li>Image-Magick動作: OK\n";
}

print <<EOM;
</ul>
</body>
</html>
EOM

exit;

