#!/usr/bin/perl

#┌─────────────────────────────────
#│  Smart Board Type-G v2.6 : diaryreg.cgi v1.0 2023/09/14
#│  copyright (c) TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# 認証モード
my %au = &authent if ($cf{authkey});

if ($in{mode} eq "diary_regist") { diary_regist(); }
if ($in{mode} eq "diary_edit") { diary_edit(); }
if ($in{mode} eq "diary_dele") { diary_dele(); }

error("不明な処理です");

#-----------------------------------------------------------
#  ダイアリー管理モード投稿記事受付
#-----------------------------------------------------------
sub diary_regist {

if ($in{addform_res}){ # 追加画像数の変更操作

	# 選択option valueの抽出
	my ($alldata,$data,$key, $value);
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	  read(STDIN, $alldata, $ENV{'CONTENT_LENGTH'});
	} else {
		  $alldata = $ENV{'QUERY_STRING'};
	}

	foreach $data (split(/&/, $alldata)) {
		  ($key, $value) = split(/=/, $data);

		  $value =~ s/\+/ /g;
		  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
		  $value =~ s/\t//g;

	$in{$key} = $value;
	}

	# データオープン
	my $flg = 0;
	my ($flg,@data);
	open(DAT,"+> $cf{addcnt}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($cnt,$dat) = split(/<>/, $in{formnum});

		if ($in{cnt} == $cnt) {
			$flg = 1;
		}
		push(@data,$_);
	}

		my $addnum = $in{formnum};

	# 時間取得
	$ENV{TZ} = "JST-9";
	my ($mday,$mon,$year) = (localtime(time))[3..5];
	my $date = sprintf("%04d/%02d/%02d", $year+1900,$mon+1,$mday);

	# データ更新
	seek(DAT, 0, 0);
	print DAT @data;
	print DAT "$addnum<>$date<>\n";
	truncate(DAT, tell(DAT));
	close(DAT);
	
	# 投稿フォーム画面に戻る
	if ($ENV{PERLXS} eq "PerlIS") {
		print "HTTP/1.0 302 Temporary Redirection\r\n";
		print "Content-type: text/html\n";
	}
	print "Location: $cf{diarybbs_cgi}?diary_res=$in{reno}&pass=$cf{diary_pass}\n\n";
}

if ($in{addform}){ # 追加画像数の変更操作

	# 選択option valueの抽出
	my ($alldata,$data,$key, $value);
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	  read(STDIN, $alldata, $ENV{'CONTENT_LENGTH'});
	} else {
		  $alldata = $ENV{'QUERY_STRING'};
	}

	foreach $data (split(/&/, $alldata)) {
		  ($key, $value) = split(/=/, $data);

		  $value =~ s/\+/ /g;
		  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
		  $value =~ s/\t//g;

	$in{$key} = $value;
	}

	# データオープン
	my $flg = 0;
	my ($flg,@data);
	open(DAT,"+> $cf{addcnt}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($cnt,$dat) = split(/<>/, $in{formnum});

		if ($in{cnt} == $cnt) {
			$flg = 1;
		}
		push(@data,$_);
	}

		my $addnum = $in{formnum};

	# 時間取得
	$ENV{TZ} = "JST-9";
	my ($mday,$mon,$year) = (localtime(time))[3..5];
	my $date = sprintf("%04d/%02d/%02d", $year+1900,$mon+1,$mday);

	# データ更新
	seek(DAT, 0, 0);
	print DAT @data;
	print DAT "$addnum<>$date<>\n";
	truncate(DAT, tell(DAT));
	close(DAT);
	
	# 投稿フォーム画面に戻る
	if ($ENV{PERLXS} eq "PerlIS") {
		print "HTTP/1.0 302 Temporary Redirection\r\n";
		print "Content-type: text/html\n";
	}
	print "Location: $cf{diarybbs_cgi}&pass=$cf{diary_pass}\n\n";
}

	# フォーム入力チェック
	form_check_diary();

	# ユーザー登録専用アイコン・キーチェック
	icon_check();

	# 投稿キーチェック
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		if ($in{captcha} !~ /^\d{$cf{cap_len}}$/) {
			error("投稿キーが入力不備です。<br>投稿フォームに戻って再読込み後、再入力してください");
		}

		# 投稿キーチェック
		# -1 : キー不一致
		#  0 : 制限時間オーバー
		#  1 : キー一致
		my $chk = cap::check($in{captcha},$in{str_crypt},$cf{captcha_key},$cf{cap_time},$cf{cap_len});
		if ($chk == 0) {
			error("投稿キーが制限時間を超過しました。<br>投稿フォームに戻って再読込み後、指定の数字を再入力してください");
		} elsif ($chk == -1) {
			error("投稿キーが不正です。<br>投稿フォームに戻って再読込み後、再入力してください");
		}
	}

	# ホスト取得
	my ($host,$addr) = get_host();

	# 時間取得
	my ($date,$time) = get_time_diary();

	# ログを開く
	my @data;
	open(DAT,"+< $cf{diarylog}") or error("open err: $cf{diarylog}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;

	# 記事NO処理
	my ($no,$ip,$time2) = split(/<>/,$top);
	$no++;

	# 連続投稿チェック
	if ($addr eq $ip && $cf{wait} > $time - $time2) {
		close(DAT);
		error("連続投稿はもうしばらく時間をおいて下さい");
	}

	# 画像アップ
	my ($e1,$w1,$h1,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11)
			= $in{upfile1} || $in{upfile2} || $in{upfile3} || $in{upfile4} || $in{upfile5} || $in{upfile6} || $in{upfile7} || $in{upfile8} || $in{upfile9} || $in{upfile10} || $in{upfile11} ? diary_upload($no) : ();

	# 削除キー暗号化
	my $crypt = encrypt($in{pwd}) if ($in{pwd} ne "");

	# YouTubeタグに改行がある場合は排除
	$in{youtube} =~ s/\n//g;

	# 親記事
	my @past;
	my ($i,$stop);
	while (<DAT>) {
		my ($no2,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$e1n,$w1n,$h1n,$chk,$myid,$color2,$tube,$time,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n,$e7n,$w7n,$h7n,$e8n,$w8n,$h8n,$e9n,$w9n,$h9n,$e10n,$w10n,$h10n,$e11n,$w11n,$h11n,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);
			$i++;
			if ($i > $cf{max} - 1) { $stop = 1; }

			if (!$stop) {
				push(@data,$_);
			} else {
				# 過去ログ
				if ($cf{pastkey}) { push(@past,$_); }

				# 添付ファイル削除
				if ($e1) {
					unlink("$cf{diaryimgdir}/$no-1$e1");
					unlink("$cf{diaryimgdir}/$no-s-1$e1") if (-f "$cf{diaryimgdir}/$no-s-1$e1");
				}
				if ($e2) {
					unlink("$cf{diaryimgdir}/$no-2$e2");
					unlink("$cf{diaryimgdir}/$no-s-2$e2") if (-f "$cf{diaryimgdir}/$no-s-2$e2");
				}
				if ($e3) {
					unlink("$cf{diaryimgdir}/$no-3$e3");
					unlink("$cf{diaryimgdir}/$no-s-3$e3") if (-f "$cf{diaryimgdir}/$no-s-3$e3");
				}
				if ($e4) {
					unlink("$cf{diaryimgdir}/$no-4$e4");
					unlink("$cf{diaryimgdir}/$no-s-4$e4") if (-f "$cf{diaryimgdir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{diaryimgdir}/$no-5$e5");
					unlink("$cf{diaryimgdir}/$no-s-5$e5") if (-f "$cf{diaryimgdir}/$no-s-5$e5");
				}
				if ($e6) {
					unlink("$cf{diaryimgdir}/$no-6$e6");
					unlink("$cf{diaryimgdir}/$no-s-6$e6") if (-f "$cf{diaryimgdir}/$no-s-6$e6");
				}
				if ($e7) {
					unlink("$cf{diaryimgdir}/$no-7$e7");
					unlink("$cf{diaryimgdir}/$no-s-7$e7") if (-f "$cf{diaryimgdir}/$no-s-7$e7");
				}
				if ($e8) {
					unlink("$cf{diaryimgdir}/$no-8$e8");
					unlink("$cf{diaryimgdir}/$no-s-8$e8") if (-f "$cf{diaryimgdir}/$no-s-8$e8");
				}
				if ($e9) {
					unlink("$cf{diaryimgdir}/$no-9$e9");
					unlink("$cf{diaryimgdir}/$no-s-9$e9") if (-f "$cf{diaryimgdir}/$no-s-9$e9");
				}
				if ($e10) {
					unlink("$cf{diaryimgdir}/$no-10$e10");
					unlink("$cf{diaryimgdir}/$no-s-10$e10") if (-f "$cf{diaryimgdir}/$no-s-10$e10");
				}
				if ($e11) {
					unlink("$cf{diaryimgdir}/$no-11$e11");
					unlink("$cf{diaryimgdir}/$no-s-11$e11") if (-f "$cf{diaryimgdir}/$no-s-11$e11");
				}
			}
		}
		unshift(@data,"$no<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$crypt<>$in{color}<>$e1<>$w1<>$h1<>0<>$au{id}<>$in{color2}<>$in{youtube}<>$time<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$e6<>$w6<>$h6<>$e7<>$w7<>$h7<>$e8<>$w8<>$h8<>$e9<>$w9<>$h9<>$e10<>$w10<>$h10<>$e11<>$w11<>$h11<>$in{tubeid}<>$in{icon}<>$in{weather}<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>$in{imgtext7}<>$in{imgtext8}<>$in{imgtext9}<>$in{imgtext10}<>$in{imgtext11}<>\n");
		unshift(@data,"$no<>$addr<>$time<>\n");

		# 過去ログ更新
		if (@past > 0) { make_past(@past); }

	# 更新
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# クッキー格納
	set_cookie($in{name},$in{email},$in{url},$in{color},$in{color2},$in{icon},$in{wico});

	# メール通知
	if ($cf{mailing} == 1) {
		my $attch01 = "$no-1$e1" if ($e1);
		my $attch02 = "$no-2$e2" if ($e2);
		my $attch03 = "$no-3$e3" if ($e3);
		my $attch04 = "$no-4$e4" if ($e4);
		my $attch05 = "$no-5$e5" if ($e5);
		my $attch06 = "$no-6$e6" if ($e6);
		my $attch07 = "$no-7$e7" if ($e7);
		my $attch08 = "$no-8$e8" if ($e8);
		my $attch09 = "$no-9$e9" if ($e9);
		my $attch10 = "$no-10$e10" if ($e10);
		my $attch11 = "$no-11$e11" if ($e11);
		mail_to($date,$host,$attch01,$attch02,$attch03,$attch04,$attch05,$attch06,$attch07,$attch08,$attch09,$attch10,$attch11);
	}

	# 完了画面
	message_diary('ありがとうございます。記事を受理しました。');
}

#-----------------------------------------------------------
#  ダイアリー管理モードユーザ記事削除
#-----------------------------------------------------------
sub diary_dele {
	$in{no} =~ s/\D//g;
	if ($in{no} eq '' || $in{pwd} eq '') {
		error("記事Noまたは暗証キーが入力モレです");
	}

	my ($top,$flg,$oya_flg,@data);
	open(DAT,"+< $cf{diarylog}") or error("open err: $cf{diarylog}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);

		# 該当記事
		if ($in{no} == $no) {
			$oya_flg = 1;
			$flg = 1;
			if ($pw eq '') {
				$flg = 2;
				last;
			}
			# 削除キー照合
			if (decrypt($in{pwd},$pw) != 1) {
				$flg = 3;
				last;
			}
				# 添付ファイル削除
				if ($e1) {
					unlink("$cf{diaryimgdir}/$no-1$e1");
					unlink("$cf{diaryimgdir}/$no-s-1$e1") if (-f "$cf{diaryimgdir}/$no-s-1$e1");
				}
				if ($e2) {
					unlink("$cf{diaryimgdir}/$no-2$e2");
					unlink("$cf{diaryimgdir}/$no-s-2$e2") if (-f "$cf{diaryimgdir}/$no-s-2$e2");
				}
				if ($e3) {
					unlink("$cf{diaryimgdir}/$no-3$e3");
					unlink("$cf{diaryimgdir}/$no-s-3$e3") if (-f "$cf{diaryimgdir}/$no-s-3$e3");
				}
				if ($e4) {
					unlink("$cf{diaryimgdir}/$no-4$e4");
					unlink("$cf{diaryimgdir}/$no-s-4$e4") if (-f "$cf{diaryimgdir}/$no-s-4$e4");
				}
				if ($e5) {
					unlink("$cf{diaryimgdir}/$no-5$e5");
					unlink("$cf{diaryimgdir}/$no-s-5$e5") if (-f "$cf{diaryimgdir}/$no-s-5$e5");
				}
				if ($e6) {
					unlink("$cf{diaryimgdir}/$no-6$e6");
					unlink("$cf{diaryimgdir}/$no-s-6$e6") if (-f "$cf{diaryimgdir}/$no-s-6$e6");
				}
				if ($e7) {
					unlink("$cf{diaryimgdir}/$no-7$e7");
					unlink("$cf{diaryimgdir}/$no-s-7$e7") if (-f "$cf{diaryimgdir}/$no-s-7$e7");
				}
				if ($e8) {
					unlink("$cf{diaryimgdir}/$no-8$e8");
					unlink("$cf{diaryimgdir}/$no-s-8$e8") if (-f "$cf{diaryimgdir}/$no-s-8$e8");
				}
				if ($e9) {
					unlink("$cf{diaryimgdir}/$no-9$e9");
					unlink("$cf{diaryimgdir}/$no-s-9$e9") if (-f "$cf{diaryimgdir}/$no-s-9$e9");
				}
				if ($e10) {
					unlink("$cf{diaryimgdir}/$no-10$e10");
					unlink("$cf{diaryimgdir}/$no-s-10$e10") if (-f "$cf{diaryimgdir}/$no-s-10$e10");
				}
				if ($e11) {
					unlink("$cf{diaryimgdir}/$no-11$e11");
					unlink("$cf{diaryimgdir}/$no-s-11$e11") if (-f "$cf{diaryimgdir}/$no-s-11$e11");
				}
				next;
		}
		push(@data,$_);
	}

	if (!$flg) {
		close(DAT);
		error("該当記事が見当たりません");
	} elsif ($flg == 2) {
		close(DAT);
		error("該当記事には暗証キーが設定されていません");
	} elsif ($flg == 3) {
		close(DAT);
		error("暗証キーが違います");
	}

	# 更新
	seek(DAT, 0, 0);
	print DAT $top;
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 完了
	message_diary("記事を削除しました");
}

#-----------------------------------------------------------
#  ダイアリー管理モード記事修正処理
#-----------------------------------------------------------
sub diary_edit {
	$in{no} =~ s/\D//g;
	if ($in{no} eq '' || $in{pwd} eq '') {
		error("記事Noまたは暗証キーが入力モレです");
	}

	# 実行
	if ($in{job} eq "edit") {

		# フォーム入力チェック
		form_check_diary();

	# ユーザー登録専用アイコン・キーチェック
	#icon_check();

	# YouTubeタグに改行がある場合は排除
	$in{youtube} =~ s/\n//g;

		# 画像アップ
		my ($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n,$e7n,$w7n,$h7n,$e8n,$w8n,$h8n,$e9n,$w9n,$h9n,$e10n,$w10n,$h10n,$e11n,$w11n,$h11n);
		if ($in{upfile1} || $in{upfile2} || $in{upfile3}|| $in{upfile4}|| $in{upfile5} || $in{upfile6} || $in{upfile7} || $in{upfile8} || $in{upfile9} || $in{upfile10} || $in{upfile11}) {
			($e1n,$w1n,$h1n,$e2n,$w2n,$h2n,$e3n,$w3n,$h3n,$e4n,$w4n,$h4n,$e5n,$w5n,$h5n,$e6n,$w6n,$h6n,$e7n,$w7n,$h7n,$e8n,$w8n,$h8n,$e9n,$w9n,$h9n,$e10n,$w10n,$h10n,$e11n,$w11n,$h11n) = add_upload($in{no});
		}

		my ($flg,@data);
		open(DAT,"+< $cf{diarylog}") or error("open err: $cf{diarylog}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);

			if ($in{no} == $no) {
				$flg = 1;
				if ($pw eq '') {
					$flg = -1;
					last;
				}
				# 削除キー照合
				if (decrypt($in{pwd},$pw) != 1) {
					$flg = -2;
					last;
				}

			# 画像削除のとき
				if ($in{del1}) {
					unlink("$cf{diaryimgdir}/$no-1$e1");
					unlink("$cf{diaryimgdir}/$no-s-1$e1") if (-f "$cf{diaryimgdir}/$no-s-1$e1");
					$e1 = $w1 = $h1 = "";
				}
				if ($in{del2}) {
					unlink("$cf{diaryimgdir}/$no-2$e2");
					unlink("$cf{diaryimgdir}/$no-s-2$e2") if (-f "$cf{diaryimgdir}/$no-s-2$e2");
					$e2 = $w2 = $h2 = "";
				}
				if ($in{del3}) {
					unlink("$cf{diaryimgdir}/$no-3$e3");
					unlink("$cf{diaryimgdir}/$no-s-3$e3") if (-f "$cf{diaryimgdir}/$no-s-3$e3");
					$e3 = $w3 = $h3 = "";
				}
				if ($in{del4}) {
					unlink("$cf{diaryimgdir}/$no-4$e4");
					unlink("$cf{diaryimgdir}/$no-s-4$e4") if (-f "$cf{diaryimgdir}/$no-s-4$e4");
					$e4 = $w4 = $h4 = "";
				}
				if ($in{del5}) {
					unlink("$cf{diaryimgdir}/$no-5$e5");
					unlink("$cf{diaryimgdir}/$no-s-5$e5") if (-f "$cf{diaryimgdir}/$no-s-5$e5");
					$e5 = $w5 = $h5 = "";
				}
				if ($in{del6}) {
					unlink("$cf{diaryimgdir}/$no-6$e6");
					unlink("$cf{diaryimgdir}/$no-s-6$e6") if (-f "$cf{diaryimgdir}/$no-s-6$e6");
					$e6 = $w6 = $h6 = "";
				}
				if ($in{del7}) {
					unlink("$cf{diaryimgdir}/$no-7$e7");
					unlink("$cf{diaryimgdir}/$no-s-7$e7") if (-f "$cf{diaryimgdir}/$no-s-7$e7");
					$e7 = $w7 = $h7 = "";
				}
				if ($in{del8}) {
					unlink("$cf{diaryimgdir}/$no-8$e8");
					unlink("$cf{diaryimgdir}/$no-s-8$e8") if (-f "$cf{diaryimgdir}/$no-s-8$e8");
					$e8 = $w8 = $h8 = "";
				}
				if ($in{del9}) {
					unlink("$cf{diaryimgdir}/$no-9$e9");
					unlink("$cf{diaryimgdir}/$no-s-9$e9") if (-f "$cf{diaryimgdir}/$no-s-9$e9");
					$e9 = $w9 = $h9 = "";
				}
				if ($in{del10}) {
					unlink("$cf{diaryimgdir}/$no-10$e10");
					unlink("$cf{diaryimgdir}/$no-s-10$e10") if (-f "$cf{diaryimgdir}/$no-s-10$e10");
					$e10 = $w10 = $h10 = "";
				}
				if ($in{del11}) {
					unlink("$cf{diaryimgdir}/$no-11$e11");
					unlink("$cf{diaryimgdir}/$no-s-11$e11") if (-f "$cf{diaryimgdir}/$no-s-11$e11");
					$e11 = $w11 = $h11 = "";
				}

				# 画像差替（拡張子が異なる場合）
				if ($e1n && $e1n ne $e1) {
					unlink("$cf{diaryimgdir}/$no-1$e1");
					unlink("$cf{diaryimgdir}/$no-s-1$e1") if (-f "$cf{diaryimgdir}/$no-s-1$e1");
				}
				if ($e2n && $e2n ne $e2) {
					unlink("$cf{diaryimgdir}/$no-2$e2");
					unlink("$cf{diaryimgdir}/$no-s-2$e2") if (-f "$cf{diaryimgdir}/$no-s-2$e2");
				}
				if ($e3n && $e3n ne $e3) {
					unlink("$cf{diaryimgdir}/$no-3$e3");
					unlink("$cf{diaryimgdir}/$no-s-3$e3") if (-f "$cf{diaryimgdir}/$no-s-3$e3");
				}
				if ($e4n && $e4n ne $e4) {
					unlink("$cf{diaryimgdir}/$no-4$e4");
					unlink("$cf{diaryimgdir}/$no-s-4$e4") if (-f "$cf{diaryimgdir}/$no-s-4$e4");
				}
				if ($e5n && $e5n ne $e5) {
					unlink("$cf{diaryimgdir}/$no-5$e5");
					unlink("$cf{diaryimgdir}/$no-s-5$e5") if (-f "$cf{diaryimgdir}/$no-s-5$e5");
				}
				if ($e6n && $e6n ne $e6) {
					unlink("$cf{diaryimgdir}/$no-6$e6");
					unlink("$cf{diaryimgdir}/$no-s-6$e6") if (-f "$cf{diaryimgdir}/$no-s-6$e6");
				}
				if ($e7n && $e7n ne $e7) {
					unlink("$cf{diaryimgdir}/$no-7$e7");
					unlink("$cf{diaryimgdir}/$no-s-7$e7") if (-f "$cf{diaryimgdir}/$no-s-7$e7");
				}
				if ($e8n && $e8n ne $e8) {
					unlink("$cf{diaryimgdir}/$no-8$e8");
					unlink("$cf{diaryimgdir}/$no-s-8$e8") if (-f "$cf{diaryimgdir}/$no-s-8$e8");
				}
				if ($e9n && $e9n ne $e9) {
					unlink("$cf{diaryimgdir}/$no-9$e9");
					unlink("$cf{diaryimgdir}/$no-s-9$e9") if (-f "$cf{diaryimgdir}/$no-s-9$e9");
				}
				if ($e10n && $e10n ne $e10) {
					unlink("$cf{diaryimgdir}/$no-10$e10");
					unlink("$cf{diaryimgdir}/$no-s-10$e10") if (-f "$cf{diaryimgdir}/$no-s-10$e10");
				}
				if ($e11n && $e11n ne $e11) {
					unlink("$cf{diaryimgdir}/$no-11$e11");
					unlink("$cf{diaryimgdir}/$no-s-11$e11") if (-f "$cf{diaryimgdir}/$no-s-11$e11");
				}

				# 画像差替
				if ($e1n) { $e1 = $e1n; $w1 = $w1n; $h1 = $h1n; }
				if ($e2n) { $e2 = $e2n; $w2 = $w2n; $h2 = $h2n; }
				if ($e3n) { $e3 = $e3n; $w3 = $w3n; $h3 = $h3n; }
				if ($e4n) { $e4 = $e4n; $w4 = $w4n; $h4 = $h4n; }
				if ($e5n) { $e5 = $e5n; $w5 = $w5n; $h5 = $h5n; }
				if ($e6n) { $e6 = $e6n; $w6 = $w6n; $h6 = $h6n; }
				if ($e7n) { $e7 = $e7n; $w7 = $w7n; $h7 = $h7n; }
				if ($e8n) { $e8 = $e8n; $w8 = $w8n; $h8 = $h8n; }
				if ($e9n) { $e9 = $e9n; $w9 = $w9n; $h9 = $h9n; }
				if ($e10n) { $e10 = $e10n; $w10 = $w10n; $h10 = $h10n; }
				if ($e11n) { $e11 = $e11n; $w11 = $w11n; $h11 = $h11n; }

				$_ = "$no<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$e1<>$w1<>$h1<>0<>$au{id}<>$in{color2}<>$in{youtube}<>$time<>$e2<>$w2<>$h2<>$e3<>$w3<>$h3<>$e4<>$w4<>$h4<>$e5<>$w5<>$h5<>$e6<>$w6<>$h6<>$e7<>$w7<>$h7<>$e8<>$w8<>$h8<>$e9<>$w9<>$h9<>$e10<>$w10<>$h10<>$e11<>$w11<>$h11<>$in{tubeid}<>$in{icon}<>$in{weather}<>$in{imgtext1}<>$in{imgtext2}<>$in{imgtext3}<>$in{imgtext4}<>$in{imgtext5}<>$in{imgtext6}<>$in{imgtext7}<>$in{imgtext8}<>$in{imgtext9}<>$in{imgtext10}<>$in{imgtext11}<>\n";
			}
			push(@data,$_);
		}

		if ($flg < 1) {
			close(DAT);
			error("不正な処理です");
		}

		# 更新
		seek(DAT, 0, 0);
		print DAT $top;
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message_diary("修正が完了しました");
	}

	my ($flg,$log);
	open(IN,"$cf{diarylog}") or error("open err: $cf{diarylog}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/);

		if ($in{no} == $no) {
			$flg = 1;
			if ($pw eq '') {
				$flg = -1;
			}
			# 削除キー照合
			if (decrypt($in{pwd},$pw) != 1) {
				$flg = -2;
			}
			$log = $_;
			last;
		}
	}
	close(IN);

	# 判定
	if (!$flg) {
		error("該当記事が見当たりません");
	} elsif ($flg == -1) {
		error("該当記事には暗証キーが設定されていません");
	} elsif ($flg == -2) {
		error("暗証キーが違います");
	}

	# 改行復元
	my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$e1,$w1,$h1,$chk,$myid,$color2,$tube,$time,$e2,$w2,$h2,$e3,$w3,$h3,$e4,$w4,$h4,$e5,$w5,$h5,$e6,$w6,$h6,$e7,$w7,$h7,$e8,$w8,$h8,$e9,$w9,$h9,$e10,$w10,$h10,$e11,$w11,$h11,$tubeid,$ico,$wico,$imgtxt1,$imgtxt2,$imgtxt3,$imgtxt4,$imgtxt5,$imgtxt6,$imgtxt7,$imgtxt8,$imgtxt9,$imgtxt10,$imgtxt11) = split(/<>/,$log);
	$com =~ s|<br( /)?>|\n|g;
	$url ||= 'http://';

	# お天気マーク
	my @wicon;
	foreach (@{$cf{w_icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@wicon,$ico);
	}
	# お天気マークプルダウン
	my $op_weather;
	foreach (0 .. $#{$cf{w_icon}}) {
		my ($icon,$nam) = split(/,/, $cf{w_icon}->[$_]);
		if ($wicon[$_] eq $wico) {
			$op_weather .= qq|<option value="$wicon[$_]" selected>$nam\n|;
		} else {
			$op_weather .= qq|<option value="$wicon[$_]">$nam\n|;
		}
	}
        #セレクトお天気マーク
	my ($selectmark,$wicon);
        	if ($wico eq '') {
			$selectmark = $wicon[0];
        	} else {
			$selectmark = $wico;
        	}

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# 旗色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	#if ($color2 eq "") { $color2 = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $color2) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ユーザー登録アイコン・ファイルの読み込み/追加
	if ($cf{user_icon} == 1) {
		put_iconlist();
	}

	# アイコン
	my @icon;
	foreach (@{$cf{icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@icon,$ico);
	}
	# アイコンプルダウン
	my @icon;
	my $op_icon;
	foreach (0 .. $#{$cf{icon}}) {
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
		if ($icon eq $ico) {
			$op_icon .= qq|<option value="$icon" selected>$nam\n|;
		} else {
			$op_icon .= qq|<option value="$icon">$nam\n|;
		}
	}
        #セレクトアイコン
	my $selecticon;
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
        	if ($ico eq '') {
			$selecticon = 'empty.png';
        	} else {
			$selecticon = $ico;
        	}

	# 添付ファイル
	my ($attach1,$attach2,$attach3,$attach4,$attach5,$attach6,$attach7,$attach8,$attach9,$attach10,$attach11);
	my %e = (1 => $e1, 2 => $e2, 3 => $e3, 4 => $e4, 5 => $e5, 6 => $e6, 7 => $e7, 8 => $e8, 9 => $e9, 10 => $e10, 11 => $e11 );

	if ($e1) {
		$attach1 .= qq|<div class="uploadBtn"><span>ファイルを選択</span><input type="file" name="upfile1" id="upload1" onchange="uv01.style.display='inline-block'; uv01.value = this.value;" /><input type="text" id="uv01" class="uploadValue" disabled /></div>\n|;
		$attach1 .= qq|<input type="text" name="imgtext1" class="reg-imgtxt" placeholder="タイトル" value="$imgtxt1" size="40">\n|;
		$attach1 .= qq|[<a href="$cf{diaryimgdir}/$no-1$e1" target="_blank">添付1</a>]\n|;
		$attach1 .= qq|<input type="checkbox" name="del1" value="1">削除1<br />\n|;
		$attach1 .= qq| <span style="color:#4753a2; font-size:10pt">コメントの左側に表示されます</span><br /><hr class="diary-edit">\n|;
	} else {
		$attach1 .= qq|<div class="uploadBtn"><span>ファイルを選択</span><input type="file" name="upfile1" id="upload1" onchange="uv01.style.display='inline-block'; uv01.value = this.value;" /><input type="text" id="uv01" class="uploadValue" disabled /></div>\n|;
		$attach1 .= qq|<br /><input type="text" name="imgtext1" class="reg-imgtxt" placeholder="ファイル名" value="$imgtxt1" size="40"><br />\n|;
		$attach1 .= qq|<span style="color:#4753a2; font-size:10pt">コメントの左側に表示されます</span>\n|;
	}

	if ($e2) {
		$attach2 .= qq|<div class="uploadButton"><span>+ Add files 01</span><input type="file" name="upfile2" id="upload2" onchange="uv02.style.display='inline-block'; uv02.value = this.value;" /><input type="text" id="uv02" class="uploadValue" disabled /></div>\n|;
		$attach2 .= qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="40">\n|;
		$attach2 .= qq|[<a href="$cf{diaryimgdir}/$no-2$e2" target="_blank">追加添付1</a>]\n|;
		$attach2 .= qq|<input type="checkbox" name="del2" value="1">削除2<br /><hr class="diary-edit">\n|;
	} else {
		$attach2 .= qq|<div class="uploadButton"><span>+ Add files 01</span><input type="file" name="upfile2" id="upload2" onchange="uv02.style.display='inline-block'; uv02.value = this.value;" /><input type="text" id="uv02" class="uploadValue" disabled /></div>\n|;
		$attach2 .= qq|<input type="text" name="imgtext2" class="reg-imgtxt" placeholder="追加添付１タイトル" value="$imgtxt2" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e3) {
		$attach3 .= qq|<div class="uploadButton"><span>+ Add files 02</span><input type="file" name="upfile3" id="upload3" onchange="uv03.style.display='inline-block'; uv03.value = this.value;" /><input type="text" id="uv03" class="uploadValue" disabled /></div>\n|;
		$attach3 .= qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="40">\n|;
		$attach3 .= qq|[<a href="$cf{diaryimgdir}/$no-3$e3" target="_blank">追加添付2</a>]\n|;
		$attach3 .= qq|<input type="checkbox" name="del3" value="1">削除3<br /><hr class="diary-edit">\n|;
	} else {
		$attach3 .= qq|<div class="uploadButton"><span>+ Add files 02</span><input type="file" name="upfile3" id="upload3" onchange="uv03.style.display='inline-block'; uv03.value = this.value;" /><input type="text" id="uv03" class="uploadValue" disabled /></div>\n|;
		$attach3 .= qq|<input type="text" name="imgtext3" class="reg-imgtxt" placeholder="追加添付２タイトル" value="$imgtxt3" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e4) {
		$attach4 .= qq|<div class="uploadButton"><span>+ Add files 03</span><input type="file" name="upfile4" id="upload4" onchange="uv04.style.display='inline-block'; uv04.value = this.value;" /><input type="text" id="uv04" class="uploadValue" disabled /></div>\n|;
		$attach4 .= qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="40">\n|;
		$attach4 .= qq|[<a href="$cf{diaryimgdir}/$no-4$e4" target="_blank">追加添付3</a>]\n|;
		$attach4 .= qq|<input type="checkbox" name="del4" value="1">削除4<br /><hr class="diary-edit">\n|;
	} else {
		$attach4 .= qq|<div class="uploadButton"><span>+ Add files 03</span><input type="file" name="upfile4" id="upload4" onchange="uv04.style.display='inline-block'; uv04.value = this.value;" /><input type="text" id="uv04" class="uploadValue" disabled /></div>\n|;
		$attach4 .= qq|<input type="text" name="imgtext4" class="reg-imgtxt" placeholder="追加添付３タイトル" value="$imgtxt4" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e5) {
		$attach5 .= qq|<div class="uploadButton"><span>+ Add files 04</span><input type="file" name="upfile5" id="upload5" onchange="uv05.style.display='inline-block'; uv05.value = this.value;" /><input type="text" id="uv05" class="uploadValue" disabled /></div>\n|;
		$attach5 .= qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="40">\n|;
		$attach5 .= qq|[<a href="$cf{diaryimgdir}/$no-5$e5" target="_blank">追加添付4</a>]\n|;
		$attach5 .= qq|<input type="checkbox" name="del5" value="1">削除5<br /><hr class="diary-edit">\n|;
	} else {
		$attach5 .= qq|<div class="uploadButton"><span>+ Add files 04</span><input type="file" name="upfile5" id="upload5" onchange="uv05.style.display='inline-block'; uv05.value = this.value;" /><input type="text" id="uv05" class="uploadValue" disabled /></div>\n|;
		$attach5 .= qq|<input type="text" name="imgtext5" class="reg-imgtxt" placeholder="追加添付４タイトル" value="$imgtxt5" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e6) {
		$attach6 .= qq|<div class="uploadButton"><span>+ Add files 05</span><input type="file" name="upfile6" id="upload6" onchange="uv06.style.display='inline-block'; uv06.value = this.value;" /><input type="text" id="uv06" class="uploadValue" disabled /></div>\n|;
		$attach6 .= qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="40">\n|;
		$attach6 .= qq|[<a href="$cf{diaryimgdir}/$no-6$e6" target="_blank">追加添付5</a>]\n|;
		$attach6 .= qq|<input type="checkbox" name="del6" value="1">削除6<br /><hr class="diary-edit">\n|;
	} else {
		$attach6 .= qq|<div class="uploadButton"><span>+ Add files 05</span><input type="file" name="upfile6" id="upload6" onchange="uv06.style.display='inline-block'; uv06.value = this.value;" /><input type="text" id="uv06" class="uploadValue" disabled /></div>\n|;
		$attach6 .= qq|<input type="text" name="imgtext6" class="reg-imgtxt" placeholder="追加添付５タイトル" value="$imgtxt6" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e7) {
		$attach7 .= qq|<div class="uploadButton"><span>+ Add files 06</span><input type="file" name="upfile7" id="upload7" onchange="uv07.style.display='inline-block'; uv07.value = this.value;" /><input type="text" id="uv07" class="uploadValue" disabled /></div>\n|;
		$attach7 .= qq|<input type="text" name="imgtext7" class="reg-imgtxt" placeholder="追加添付６タイトル" value="$imgtxt7" size="40">\n|;
		$attach7 .= qq|[<a href="$cf{diaryimgdir}/$no-7$e7" target="_blank">追加添付6</a>]\n|;
		$attach7 .= qq|<input type="checkbox" name="del7" value="1">削除7<br /><hr class="diary-edit">\n|;
	} else {
		$attach7 .= qq|<div class="uploadButton"><span>+ Add files 06</span><input type="file" name="upfile7" id="upload7" onchange="uv07.style.display='inline-block'; uv07.value = this.value;" /><input type="text" id="uv07" class="uploadValue" disabled /></div>\n|;
		$attach7 .= qq|<input type="text" name="imgtext7" class="reg-imgtxt" placeholder="追加添付６タイトル" value="$imgtxt7" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e8) {
		$attach8 .= qq|<div class="uploadButton"><span>+ Add files 07</span><input type="file" name="upfile8" id="upload8" onchange="uv08.style.display='inline-block'; uv08.value = this.value;" /><input type="text" id="uv08" class="uploadValue" disabled /></div>\n|;
		$attach8 .= qq|<input type="text" name="imgtext8" class="reg-imgtxt" placeholder="追加添付７タイトル" value="$imgtxt8" size="40">\n|;
		$attach8 .= qq|[<a href="$cf{diaryimgdir}/$no-8$e8" target="_blank">追加添付7</a>]\n|;
		$attach8 .= qq|<input type="checkbox" name="del8" value="1">削除8<br /><hr class="diary-edit">\n|;
	} else {
		$attach8 .= qq|<div class="uploadButton"><span>+ Add files 07</span><input type="file" name="upfile8" id="upload8" onchange="uv08.style.display='inline-block'; uv08.value = this.value;" /><input type="text" id="uv08" class="uploadValue" disabled /></div>\n|;
		$attach8 .= qq|<input type="text" name="imgtext8" class="reg-imgtxt" placeholder="追加添付７タイトル" value="$imgtxt8" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e9) {
		$attach9 .= qq|<div class="uploadButton"><span>+ Add files 08</span><input type="file" name="upfile9" id="upload9" onchange="uv09.style.display='inline-block'; uv09.value = this.value;" /><input type="text" id="uv09" class="uploadValue" disabled /></div>\n|;
		$attach9 .= qq|<input type="text" name="imgtext9" class="reg-imgtxt" placeholder="追加添付８タイトル" value="$imgtxt9" size="40">\n|;
		$attach9 .= qq|[<a href="$cf{diaryimgdir}/$no-9$e9" target="_blank">追加添付8</a>]\n|;
		$attach9 .= qq|<input type="checkbox" name="del9" value="1">削除9<br /><hr class="diary-edit">\n|;
	} else {
		$attach9 .= qq|<div class="uploadButton"><span>+ Add files 08</span><input type="file" name="upfile9" id="upload9" onchange="uv09.style.display='inline-block'; uv09.value = this.value;" /><input type="text" id="uv09" class="uploadValue" disabled /></div>\n|;
		$attach9 .= qq|<input type="text" name="imgtext9" class="reg-imgtxt" placeholder="追加添付８タイトル" value="$imgtxt9" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e10) {
		$attach10 .= qq|<div class="uploadButton"><span>+ Add files 09</span><input type="file" name="upfile10" id="upload10" onchange="uv10.style.display='inline-block'; uv10.value = this.value;" /><input type="text" id="uv10" class="uploadValue" disabled /></div>\n|;
		$attach10 .= qq|<input type="text" name="imgtext10" class="reg-imgtxt" placeholder="追加添付９タイトル" value="$imgtxt10" size="40">\n|;
		$attach10 .= qq|[<a href="$cf{diaryimgdir}/$no-10$e10" target="_blank">追加添付9</a>]\n|;
		$attach10 .= qq|<input type="checkbox" name="del10" value="1">削除10<br /><hr class="diary-edit">\n|;
	} else {
		$attach10 .= qq|<div class="uploadButton"><span>+ Add files 09</span><input type="file" name="upfile10" id="upload10" onchange="uv10.style.display='inline-block'; uv10.value = this.value;" /><input type="text" id="uv10" class="uploadValue" disabled /></div>\n|;
		$attach10 .= qq|<input type="text" name="imgtext10" class="reg-imgtxt" placeholder="追加添付９タイトル" value="$imgtxt10" size="40"><br /><hr class="diary-edit">\n|;
	}

	if ($e11) {
		$attach11 .= qq|<div class="uploadButton"><span>+ Add files 10</span><input type="file" name="upfile11" id="upload11" onchange="uv11.style.display='inline-block'; uv11.value = this.value;" /><input type="text" id="uv11" class="uploadValue" disabled /></div>\n|;
		$attach11 .= qq|<input type="text" name="imgtext11" class="reg-imgtxt" placeholder="追加添付１０タイトル" value="$imgtxt11" size="40">\n|;
		$attach11 .= qq|[<a href="$cf{diaryimgdir}/$no-11$e11" target="_blank">追加添付10</a>]\n|;
		$attach11 .= qq|<input type="checkbox" name="del11" value="1">削除11<br /><hr class="diary-edit">\n|;
	} else {
		$attach11 .= qq|<div class="uploadButton"><span>+ Add files 10</span><input type="file" name="upfile11" id="upload11" onchange="uv11.style.display='inline-block'; uv11.value = this.value;" /><input type="text" id="uv11" class="uploadValue" disabled /></div>\n|;
		$attach11 .= qq|<input type="text" name="imgtext11" class="reg-imgtxt" placeholder="追加添付１０タイトル" value="$imgtxt11" size="40"><br /><hr class="diary-edit">\n|;
	}

	# トピック画面用
	$in{bbs} ||= 0;
	my $read = $in{bbs} == 1 ? $in{no} : 0;

	# 修正フォーム
	open(IN,"$cf{tmpldir}/diary_edit.html") or error("open err: diary_edit.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tube =~ s/&lt;/</g;
	$tube =~ s/&gt;/>/g;
	$tube =~ s/&quot;/"/g;
	$tube =~ s/&amp;/&/g;

	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/smart.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/smart-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!num!/$in{no}/g;
	$tmpl =~ s/!pass!/$cf{diary_pass}/g;
	$tmpl =~ s/!pwd!/$in{pwd}/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!email!/$eml/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!comment!/$com/g;
	$tmpl =~ s/!url!/$url/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s/<!-- op_icon -->/$op_icon/g;
	$tmpl =~ s/<!-- op_weather -->/$op_weather/g;
	$tmpl =~ s|<!-- select_mark -->|<div id="weather_selected"><div class="select"><img id="imagechange" src="$cf{weatherurl}/$selectmark" width="47px" height="30px" alt=""></div></div>|g;

	if (!$icon) {
		$tmpl =~ s|<!-- select_icon -->||g;
	} else {
		$tmpl =~ s|<!-- select_icon -->|<div id="Selected_edit_ad"><div class="select"><img id="imgchange" src="$cf{faceurl}/$selecticon" width="80px" height="80px" alt=""></div></div>|g;
	}

	$tmpl =~ s/!color2!/$color2/g;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/!bbs!/$in{bbs}/g;
	$tmpl =~ s/!read!/$read/g;
	$tmpl =~ s/<!-- youtube -->/$tube/;
	$tmpl =~ s/!tube_id!/$tubeid/;
	$tmpl =~ s/<!-- attach:1 -->/$attach1/g;
	$tmpl =~ s/<!-- attach:2 -->/$attach2/g;
	$tmpl =~ s/<!-- attach:3 -->/$attach3/g;
	$tmpl =~ s/<!-- attach:4 -->/$attach4/g;
	$tmpl =~ s/<!-- attach:5 -->/$attach5/g;
	$tmpl =~ s/<!-- attach:6 -->/$attach6/g;
	$tmpl =~ s/<!-- attach:7 -->/$attach7/g;
	$tmpl =~ s/<!-- attach:8 -->/$attach8/g;
	$tmpl =~ s/<!-- attach:9 -->/$attach9/g;
	$tmpl =~ s/<!-- attach:10 -->/$attach10/g;
	$tmpl =~ s/<!-- attach:11 -->/$attach11/g;
	$tmpl =~ s/!sub_len!/$cf{sub_len}/g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  ユーザー登録アイコン・リスト挿入
#-----------------------------------------------------------
sub put_iconlist{

	my @log;
	open(IN,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<IN>) {
		push(@log,$_);
	}
	close(IN);
	foreach (@log) {
		my ($no,$date,$nam,$sub,$com,$hos,$pw,$ex,$w,$h,$only) = split(/<>/);

		if ($only) { 
			$only = "（$nam 様専用）"; 
		} else { 
			$only = "（共用アイコン）";
		}

		push(@{$cf{icon}},"$no$ex,<span style=\"color:#008db7\">＊ $sub$only</span>") if ($cf{user_icon});
	}
}

#-----------------------------------------------------------
#  ユーザー登録・専用アイコン・チェック
#-----------------------------------------------------------
sub icon_check {
	$in{no} =~ s/\D//g;

	my ($alldata,$data,$key, $value);
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	  read(STDIN, $alldata, $ENV{'CONTENT_LENGTH'});
	} else {
		  $alldata = $ENV{'QUERY_STRING'};
	}

	foreach $data (split(/&/, $alldata)) {
		  ($key, $value) = split(/=/, $data);

		  $value =~ s/\+/ /g;
		  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
		  $value =~ s/\t//g;

	$in{"$key"} = $value;
	}

	my ($no,$ext) = split(/<>/, $in{'icon'});
	$in{no} = $no;

	my ($flg,$name);
	open(ICON,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<ICON>) {
		my ($no2,$date,$nam2,$sub2,$com,$hos,$pass,$ex2,$w,$h,$only) = split(/<>/);
		if ($in{no} == $no2) {
			$flg = 1;

				$name = $nam2;

			# アイコン登録キー照合
			if ($only == 1) {
				if (decrypt($in{pwd},$pass) != 1) {
					$flg = -2;
				}
			}
			last;
		}
	}
	close(ICON);
	
	# 判定
	if ($flg == -2) {
		error("このアイコンは$name様専用アイコンです！<br />アイコン登録時の登録キーを入力して下さい。");
	}
}


#-----------------------------------------------------------
#  過去ログ生成
#-----------------------------------------------------------
sub make_past {
	my @past = @_;

	# 過去ログNOファイル
	open(NO,"+< $cf{nofile}") or error("open err: $cf{nofile}");
	eval "flock(NO, 2);";
	my $num = <NO>;

	# 過去ログを定義
	my $pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

	# 過去ログを開く
	open(LOG,"+< $pastfile") or error("open err: $pastfile");
	eval "flock(LOG, 2);";
	my @data = <LOG>;

	# 規定行数オーバー時、次ファイル生成
	if (@data > $cf{pastmax}) {

		# 過去ログを閉じる
		@data = ();
		close(LOG);

		# 過去NO更新
		seek(NO, 0, 0);
		print NO ++$num;
		truncate(NO, tell(NO));
		close(NO);

		$pastfile = "$cf{pastdir}/" . sprintf("%04d",$num) . ".cgi";

		open(LOG,"+> $pastfile");
		eval "flock(LOG, 2);";
		print LOG @past;
		close(LOG);

		chmod(0666, $pastfile);

	# 規定内
	} else {

		# 過去NOファイルを閉じる
		close(NO);

		# 過去ログ更新
		seek(LOG, 0, 0);
		print LOG @past;
		print LOG @data;
		truncate(LOG, tell(LOG));
		close(LOG);
	}
}

#-----------------------------------------------------------
#  ダイアリーフォーム入力チェック
#-----------------------------------------------------------
sub form_check_diary {

	# 不要改行カット
	$in{sub}  =~ s|<br>||g;
	$in{pwd}  =~ s|<br>||g;
	$in{captcha} =~ s|<br>||g;
	$in{color} =~ s/\D//g;
	$in{icon}  =~ s|<br />||g;
	$in{comment} =~ s|(<br>)+$||g;
	
	# チェック
	if ($cf{no_wd}) { no_wd(); }
	if ($cf{jp_wd}) { jp_wd(); }
	if ($cf{urlnum} > 0) { urlnum(); }
	
	# 入力値調整
	if ($in{url} eq 'http://') { $in{url} = ''; }
	$in{sub} ||= "無題";
	
	# 入力項目チェック
	my $err;
	if (count_str($in{sub}) > $cf{sub_len}) {
		$err .= "タイトル名は$cf{sub_len}文字以内です<br>";
	}
	if ($in{comment} eq "") { $err .= "コメントが入力されていません<br>"; }
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "URL情報が不正です<br>";
	}
	if ($cf{my_icon} == 1 && $in{icon} eq $cf{my_gif}) {
		if ($in{pwd} ne $cf{password}) {
			$err .= "管理者アイコンは管理者以外は選択できません<br />";
		}
	}
	error($err) if ($err);
}

#-----------------------------------------------------------
#  メール送信
#-----------------------------------------------------------
sub mail_to {
	my ($date,$host,$attch01,$attch02,$attch03,$attch04,$attch05,$attch06,$attch07,$attch08,$attch09,$attch10,$attch11) = @_;
	
	# 件名をMIMEエンコード
	require './lib/jacode.pl';
	my $msub = mime_unstructured_header("BBS: $in{sub}");
	
	# コメント内の改行復元
	my $com = $in{comment};
	$com =~ s|<br />|\n|g;
	$com =~ s/&lt;/>/g;
	$com =~ s/&gt;/</g;
	$com =~ s/&quot;/"/g;
	$com =~ s/&amp;/&/g;
	$com =~ s/&#39;/'/g;

	# メール本文を定義
	my $mbody = <<"EOM";
掲示板に投稿がありました。

投稿日：$date
ホスト：$host

件名  ：$in{sub}
お名前：$in{name}
E-mail：$in{email}
URL   ：$in{url}
添付01  ：$attch01
添付02  ：$attch02
添付03  ：$attch03
添付04  ：$attch04
添付05  ：$attch05
添付06  ：$attch06
添付07  ：$attch07
添付08  ：$attch08
添付09  ：$attch09
添付10  ：$attch10
添付11  ：$attch11

$com
EOM

	# JISコード変換
	my $body;
	for my $tmp ( split(/\n/,$mbody) ) {
		jcode::convert(\$tmp,'jis','utf8');
		$body .= "$tmp\n";
	}

	# メールアドレスがない場合は管理者メールに置き換え
	$in{email} ||= $cf{mailto};

	# sendmailコマンド
	my $scmd = "$cf{sendmail} -t -i";
	if ($cf{sendm_f}) {
		$scmd .= " -f $in{email}";
	}

	# 送信
	open(MAIL,"| $scmd") or error("送信失敗");
	print MAIL "To: $cf{mailto}\n";
	print MAIL "From: $in{email}\n";
	print MAIL "Subject: $msub\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: $cf{version}\n\n";
	print MAIL "$mbody\n";
	close(MAIL);
}

#-----------------------------------------------------------
#  DIARY MODE時間取得
#-----------------------------------------------------------
sub get_time_diary {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|日曜日 月曜日 火曜日 水曜日 木曜日 金曜日 土曜日|;
	
	# 日時のフォーマット
	my $date = sprintf("%04d年%02d月%02d日(%s)",
			$year+1900,$mon+1,$mday,$week[$wday]);
	
	return ($date, $time);
}

#-----------------------------------------------------------
#  禁止ワードチェック
#-----------------------------------------------------------
sub no_wd {
	my $flg;
	foreach ( split(/,/, $cf{no_wd}) ) {
		if (index("$in{name} $in{sub} $in{comment}", $_) >= 0) {
			$flg = 1;
			last;
		}
	}
	if ($flg) { error("禁止ワードが含まれています"); }
}

#-----------------------------------------------------------
#  日本語チェック
#-----------------------------------------------------------
sub jp_wd {
	if ($in{comment} !~ /(?:[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3})/x) {
		error("メッセージに日本語が含まれていません");
	}
}

#-----------------------------------------------------------
#  URL個数チェック
#-----------------------------------------------------------
sub urlnum {
	my $com = $in{comment};
	my ($num) = ($com =~ s|(https?://)|$1|ig);
	if ($num > $cf{urlnum}) {
		error("コメント中のURLアドレスは最大$cf{urlnum}個までです");
	}
}

#-----------------------------------------------------------
#  ホスト名取得
#-----------------------------------------------------------
sub get_host {
	# IP&ホスト取得
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IPチェック
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		error("アクセスを許可されていません");

	# ホストチェック
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			error("アクセスを許可されていません");
		}
	}
	$host ||= $addr;
	return ($host, $addr);
}

#-----------------------------------------------------------
#  crypt暗号
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  crypt照合
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  ダイアリー完了メッセージ
#-----------------------------------------------------------
sub message_diary {
	my ($msg) = @_;
	
	open(IN,"$cf{tmpldir}/msg_diary.html") or error("open err: msg_diary.html");
	my $tmpl = join('',<IN>);
	close(IN);
	
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!message!/$msg/g;
	$tmpl =~ s/!pass!/$cf{diary_pass}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/smart.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/smart-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  認証モード
#-----------------------------------------------------------
sub authent {
	# セッションモジュール取り込み
	require $cf{session_pl};

	# セッション管理
	&session($cf{sesdir},$cf{bbs_cgi});
}

#-----------------------------------------------------------
#  クッキー発行
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
	- <a href="https://www.kent-web.com/" target="_top">Joyful Note</a> -<br />
	- <a href="https://www.transformsite.com/" target="_top">$cf{version}</a> -<br>
	++ <a href="https://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  添付アップロード
#-----------------------------------------------------------
sub diary_upload {
	my $num = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	my @ret;
	foreach my $i (1 .. 11) {

		# mimeタイプ
		my $mime = $cgi->param_mime("upfile$i");

		# 拡張子取得
		my $fname = $cgi->param_filename("upfile$i");
		if ($fname =~ /(\.jpe?g|\.png|\.gif|\.pdf|\.txt|\.doc|\.docx|\.xls|\.xlsx|\.ppt|\.pptx|\.zip|\.mp3|\.mp4)$/i) {
			my $ex = $1;
			$ex =~ tr/A-Z/a-z/;
			if ($ex eq '.jpeg') { $ex = '.jpg'; }

			# 整合性チェック
			my $flg;
			if ($cf{ok_gif}) {
				if ($mime =~ /^image\/gif$/i and $ex eq '.gif') { $flg++; }
			}
			if (!$flg and $cf{ok_jpeg}) {
				if ($mime =~ /^image\/p?jpe?g$/i and $ex eq '.jpg') { $flg++; }
			}
			if (!$flg and $cf{ok_png}) {
				if ($mime =~ /^image\/(x-)?png$/i and $ex eq '.png') { $flg++; }
			}
			if (!$flg and $cf{ok_pdf}) {
				if ($mime =~ /^application\/pdf$/i and $ex eq '.pdf') { $flg++; }
			}
			if (!$flg and $cf{ok_zip}) {
				if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ex eq '.zip') { $flg++; }
			}
			if (!$flg and $cf{ok_text}) {
				if ($mime =~ /^text\/plain$/i and $ex =~ /^\.te?xt$/) { $flg++; }
			}
			if (!$flg and $cf{ok_word}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ex eq '.doc') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ex eq '.docx') { $flg++; }
			}
			if (!$flg and $cf{ok_excel}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ex eq '.xls') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ex eq '.xlsx') { $flg++; }
			}
			if (!$flg and $cf{ok_ppt}) {
				if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ex eq '.ppt') { $flg++; }
				elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ex eq '.pptx') { $flg++; }
			}
			if (!$flg and $cf{ok_mp3}) {
				if ($mime =~ /^audio\/mpeg$/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mp3/i and $ex eq '.mp3') { $flg++; }
				elsif ($mime =~ /^audio\/mpg/i and $ex eq '.mp3') { $flg++; }
			}
			if (!$flg and $cf{ok_mp4}) {
				if ($mime =~ /^video\/mpeg$/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mp4/i and $ex eq '.mp4') { $flg++; }
				elsif ($mime =~ /^video\/mpg/i and $ex eq '.mp4') { $flg++; }
			}
			if (!$flg) { error('このファイルは取り扱いできません'); }

		# 添付ファイル定義
		my $upfile = "$cf{diaryimgdir}/$num-$i$ex";

		# アップロード書き込み
		open(UP,"+> $upfile") or error("up err: $upfile");
		binmode(UP);
		print UP $in{"upfile$i"};
		close(UP);

		# パーミッション付与
		chmod(0666,$upfile);

		# 画像の場合サイズ取得
		my ($flg,$w,$h);
		if ($ex eq ".jpg") { ($w,$h) = j_size($upfile); $flg++; }
		elsif ($ex eq ".gif") { ($w,$h) = g_size($upfile); $flg++; }
		elsif ($ex eq ".png") { ($w,$h) = p_size($upfile); $flg++; }

		# サムネイル作成
		if ($flg && $cf{thumbnail}) {
			($w,$h) = resize($w,$h);
			my $thumb = "$cf{diaryimgdir}/$num-s-$i$ex";
			make_thumb($upfile,$thumb,$w,$h);
		}

		# 拡張子, 横幅, 縦幅 の順
			push(@ret,($ex,$w,$h));
		} else {
			push(@ret,('','',''));
		}
	}
	# 結果を返す
	return @ret;
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}


#-----------------------------------------------------------
#  mimeエンコード
#  [quote] http://www.din.or.jp/~ohzaki/perl.htm#JP_Base64
#-----------------------------------------------------------
sub mime_unstructured_header {
  my $oldheader = shift;
  jcode::convert(\$oldheader,'euc','utf8');
  my ($header,@words,@wordstmp,$i);
  my $crlf = $oldheader =~ /\n$/;
  $oldheader =~ s/\s+$//;
  @wordstmp = split /\s+/, $oldheader;
  for ($i = 0; $i < $#wordstmp; $i++) {
    if ($wordstmp[$i] !~ /^[\x21-\x7E]+$/ and
	$wordstmp[$i + 1] !~ /^[\x21-\x7E]+$/) {
      $wordstmp[$i + 1] = "$wordstmp[$i] $wordstmp[$i + 1]";
    } else {
      push(@words, $wordstmp[$i]);
    }
  }
  push(@words, $wordstmp[-1]);
  foreach my $word (@words) {
    if ($word =~ /^[\x21-\x7E]+$/) {
      $header =~ /(?:.*\n)*(.*)/;
      if (length($1) + length($word) > 76) {
	$header .= "\n $word";
      } else {
	$header .= $word;
      }
    } else {
      $header = add_encoded_word($word, $header);
    }
    $header =~ /(?:.*\n)*(.*)/;
    if (length($1) == 76) {
      $header .= "\n ";
    } else {
      $header .= ' ';
    }
  }
  $header =~ s/\n? $//mg;
  $crlf ? "$header\n" : $header;
}
sub add_encoded_word {
  my ($str, $line) = @_;
  my $result;
  my $ascii = '[\x00-\x7F]';
  my $twoBytes = '[\x8E\xA1-\xFE][\xA1-\xFE]';
  my $threeBytes = '\x8F[\xA1-\xFE][\xA1-\xFE]';
  while (length($str)) {
    my $target = $str;
    $str = '';
    if (length($line) + 22 +
	($target =~ /^(?:$twoBytes|$threeBytes)/o) * 8 > 76) {
      $line =~ s/[ \t\n\r]*$/\n/;
      $result .= $line;
      $line = ' ';
    }
    while (1) {
      my $encoded = '=?ISO-2022-JP?B?' .
      b64encode(jcode::jis($target,'euc','z')) . '?=';
      if (length($encoded) + length($line) > 76) {
	$target =~ s/($threeBytes|$twoBytes|$ascii)$//o;
	$str = $1 . $str;
      } else {
	$line .= $encoded;
	last;
      }
    }
  }
  $result . $line;
}
# [quote] http://www.tohoho-web.com/perl/encode.htm
sub b64encode {
    my $buf = shift;
    my ($mode,$tmp,$ret);
    my $b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                . "abcdefghijklmnopqrstuvwxyz"
                . "0123456789+/";
	
    $mode = length($buf) % 3;
    if ($mode == 1) { $buf .= "\0\0"; }
    if ($mode == 2) { $buf .= "\0"; }
    $buf =~ s/(...)/{
        $tmp = unpack("B*", $1);
        $tmp =~ s|(......)|substr($b64, ord(pack("B*", "00$1")), 1)|eg;
        $ret .= $tmp;
    }/eg;
    if ($mode == 1) { $ret =~ s/..$/==/; }
    if ($mode == 2) { $ret =~ s/.$/=/; }
    
    return $ret;
}

#-----------------------------------------------------------
#  文字数カウント for UTF-8
#-----------------------------------------------------------
sub count_str {
	my ($str) = @_;
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	
	my $i = 0;
	while ($str =~ /($byte1|$byte2|$byte3|$byte4)/gx) {
		$i++;
	}
	return $i;
}

1;

