# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ JOYFUL NOTE : init.cgi - 2021/07/24
#│ copyright (c) kentweb, 1997-2020
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Smart Board Type-G v2.6 init.cgi 2023/09/14
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
$cf{version} = 'Smart Board Type-G v2.6';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このスクリプトはフリーソフトです。このスクリプトを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
#===========================================================
# ■ 設定項目
#===========================================================

# アクセス制限をする
# 0=no 1=yes
$cf{authkey} = 1;

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 0;

# 掲示板タイトル
$cf{bbs_title} = "Smart Board Type-G v2.6";

# アップロードファイル管理者チェック機能 (0=no 1=yes)
# → アップロードファイルは管理者がチェック後表示
$cf{img_check} = 0;

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# 記事内コメントアイコン等URL
$cf{com_iconurl} = "./cmn/icon";

#------------------------------------------------------------#

# ダイアリー投稿パスワード設定
$cf{diary_pass} = '9999';

# ダイアリー投稿フォーム・追加添付参照フォーム数を変更した時の戻るURL {新規投稿}【URLパス】
$cf{diarybbs_cgi} = './smart.cgi?mode=diary_adm';

# ダイアリーモード書込CGIのURL【URLパス】
$cf{diaryreg_cgi} = './diaryreg.cgi';

# ダイアリーログファイル【サーバパス】
$cf{diarylog} = './data/diarylog.cgi';

# ダイアリーアップロードディレクトリ【サーバパス】
$cf{diaryimgdir} = './diaryimg';

# ダイアリーアップロードディレクトリ【URLパス】
$cf{diaryimgurl} = "./diaryimg";

# モード切り替えデータ【サーバパス】
$cf{changecnt} = './data/exchange.dat';

# モード切り替えフォーム入室パスワード設定
$cf{mode_pass} = '8888';

# ダイアリーユーザーアイコン登録CGIのURL【URLパス】
$cf{dicoreg_cgi} = './diaryicoreg.cgi';

#------------------------------------------------------------#

# 追加添付ファイル入力フォーム数（MAX=10）
# maxで「5」の場合は[0,1,2,3,4,5]、または[0,1,3,5]などに変更。
# maxで「10」の場合は[0,1,2,3,4,5,6,7,8,9,10]、または[0,1,3,5,7,9,10]などに変更。
$cf{addattach} = [0,1,2,3,6,9,10];

# 追加添付ファイル入力フォーム数の初期値
# 閲覧者が初めてこの掲示板を開いた時に見る入力フォームの行数です。
# 変更可能な数値は「0～9」までの数値です。初期数値は「3」に設定されています。
$cf{attach_defo} = 1;

# 追加添付ファイル採番ファイル【サーバパス】
$cf{addcnt} = './data/addno.dat';

# 入力フォーム数変更後戻るアドレス【URLパス】
$cf{checge_url} = './smart.cgi?mode=form';

# ------------------------------------------------------------#

# 掲示板直リンク対策 (0=no 1=yes)
$cf{refstep} = 0;

# 掲示板直リンク対策時にリダイレクトするウェブページ
# 通常、サイトのTOP PAGEを指定して、メニューから掲示板に誘導する。
# 戻り先のURL【URLパス】
$cf{redirect} = "https://www.transformsite.com/sample/except/smart_board_g/referer_error.html";

#-------------------------------------------------------------------------#
# アイコンモード機能
# 0 : アイコン不使用
# 1 : アイコン使用
$cf{icon_mode} = 1;

# 顔アイコン画像のあるディレクトリ【URLパス】
$cf{faceurl} = "./cmn/face";

# アイコン
# → 「ファイル名」とその「キャラクタ名」をコンマで区切る
$cf{icon} = [
	"empty.png,選択して下さい.....",
	"rean.png,リィン・シュバルツァー",
	"juna.png,ユウナ・クロフォード",
	"kurt.png,クルト・ヴァンダール",
	"altina.png,アルティナ・オフライン",
	"randolph.png,ランドルフ・オルランド",
	"estelle.png,エステル・ブライト",
	"ash.png,アッシュ・カーバイド",
	"towa.png,トワ・ハーシェル",
	"musse.png,ミュゼ・イーグレット",
	"tita.png,ティータ・ラッセル",
	"aurelia.png,オーレリア・ルグィン",
	"michael.png,ミハイル少佐",
	"schmitt.png,G・シュミット博士",
	"alisa.png,アリサ・ラインフォルト",
	"eliot.png,エリオット・クレイグ",
	"laura.png,ラウラ・S・アルゼイド",
	"jusis.png,ユーシス・アルバレア",
	"machias.png,マキアス・レーグニッツ",
	"fie.png,フィー・クラウゼル",
	"emma.png,エマ・ミルスティン",
	"misty.png,ミスティ",
	"gaius.png,ガイウス・ウォーゼル",
	"millium.png,ミリアム・オライオン",
	"sara.png,サラ・バレスタイン",
	"agate.png,アガット・クロスナー",
	"tio.png,ティオ・プラトー",
	"olivert.png,オリヴァルト皇子",
	"cedric.png,セドリック皇太子",
	"alfin.png,アルフィン皇女",
	"osborne.png,ギリアス・オズボーン",
	"rufus.png,ルーファス・アルバレア",
	"claire.png,クレア・リーヴェルト",
	"lecter.png,レクター・アランドール",
	"elise.png,エリゼ・シュバルツァー",
	"angelica.png,アンゼリカ・ログナー",
	"georges.png,ジョルジュ・ノーム",
	"victor.png,ヴィクター・S・アルゼイド",
	"sharon.png,シャロン・クルーガー",
	"campanella.png,《道化師》カンパネラル",
	"shirley.png,《紅の戦鬼》シャーリィ・オルランド",
	"arianrhod.png,《鋼の聖女》アリアンロード",
	"dubarry.png,《神速》のデュバリィ",
	"aines.png,《剛殻》のアイネス",
	"ennea.png,《魔弓》のエンネア",
	"siegfried.png,《蒼》のジークフリード",
	"roselia.png,《緋》のローゼリア",
	"clotilde.png,ヴィータ・クロチルダ",
	"rutger.png,《猟兵王》ルトガー・クラウゼル",
	"elaina_ico01.png,イレイナ01",
	"elaina_ico02.png,イレイナ02",
	"elaina_ico03.png,イレイナ03",
	"elaina_ico04.png,イレイナ04",
	"elaina_ico05.png,イレイナ05",
	"saya_ico01.png,サヤ01",
	"fran_ico01.png,フラン01",
	"fran_ico02.png,フラン02",
	"sheila_ico01.png,シーラ01",
	"sheila_ico02.png,シーラ02",
	"sheila_ico03.png,シーラ03",
	"amnesia.png,アムネシア",
	"arte.png,アルテ",
	"avilia.png,アヴィリア",
	"emery.png,エメリー",
	"estel.png,エステル",
	"houki.png,ホウキ",
	"karen.png,カレン",
	"LeSchera.png,ルシェーラ",
	"lilytia.png,リリーティア",
	"linaria.png,リネリア",
	"monica.png,モニカ",
	"Riera.png,リエラ",
	"sario.png,サリオ",
	"ursula.png,ウルスラ",
	];

# ユーザーアイコン登録CGIのURL【URLパス】
$cf{icoreg_cgi} = './icoreg.cgi';

# ダイアリーモード・ユーザーアイコン登録CGIのURL【URLパス】
$cf{diaryicoreg_cgi} = './diaryicoreg.cgi';

# ユーザーアイコン情報ログファイル【サーバパス】
$cf{iconfile} = './data/iconfile.cgi';

# ユーザーアイコン登録【サーバパス】
$cf{user_icon} = 1;

# 登録アイコンファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{ico_max_img_w} = 80;
$cf{ico_max_img_h} = 80;

#-------------------------------------------------------------------------#
# お天気マーク
# ダイアリーモードのみ
# → 「ファイル名」とその「マーク名」をコンマで区切る
$cf{w_icon} = [
	"drizzling.png,霧雨",
	"rainy.png,小雨",
	"light_rain.png,雨",
	"heavy_rain.png,強雨",
	"rainstorm.png,暴風雨",
	"tempest.png,豪雨",
	"cloud_sunny.png,雨時々晴れ",
	"rain_cloud.png,雨時々曇り",
	"rain_snow.png,雨時々雪",
	"rainy_then_sunny.png,雨後晴れ",
	"rainy_then_cloudy.png,雨後曇り",
	"rainy_then_snowy.png,雨後雪",
	"rainy_snow_then_sunny.png,雨か雪後晴れ",
	"rain_snow_then_cloudy.png,雨か雪後曇り",
	"rainy_lightsnow.png,雨時々小雪",
	"sunny.png,晴れ",
	"moonlight.png,晴れ(夜)",
	"sunny_cloud.png,晴れ時々曇り",
	"sunny_rain.png,晴れ時々雨",
	"sunny_snow.png,晴れ時々雪",
	"partly_cloudy.png,晴れ後曇り",
	"sunny_then_rainy.png,晴れ後雨",
	"sunny_then_snowy.png,晴れ後雪",
	"sunny_then_rain_snow.png,晴れ後雨か小雪",
	"sunny_then_snow_rain.png,晴れ後雪か小雨",
	"sunny_rain_snow.png,晴れ時々雨か小雪",
	"sunny_snow_rain.png,晴れ時々雪か小雨",
	"cloudy.png,曇り",
	"cloudy_sunny.png,曇り時々晴れ",
	"cloud_rain.png,曇り時々雨",
	"cloud_snow.png,曇り時々雪",
	"partly_sunny.png,曇り後晴れ",
	"cloudy_then_rainy.png,曇り後雨",
	"cloudy_then_snowy.png,曇り後雪",
	"cloudy_then_rain_lightsnow.png,曇り後雨か小雪",
	"cloudy_then_snow_lightrain.png,曇り後雪か小雨",
	"cloudy_snowy_lightrain.png,曇り時々雪か小雨",
	"cloudy_rainy_lightsnow.png,曇り時々雨か小雪",
	"snowy.png,雪",
	"snowy_sunny.png,雪時々晴れ",
	"snowy_cloudy.png,雪時々曇り",
	"snowy_rainy.png,雪時々雨",
	"snowy_then_sunny.png,雪後晴れ",
	"snowy_then_cloudy.png,雪後曇り",
	"snowy_then_rainy.png,雪後雨",
	"snowy_lightrain_then_sunny.png,雪か小雨後晴れ",
	"snowy_lightrain_then_cloudy.png,雪か小雨後曇り",
	"dry_snow.png,乾いた雪",
	"wet_snow.png,湿った雪",
	"snowstorm.png,暴風雪",
	"sleet.png,霙(みぞれ)",
	"snowy_lightrain.png,雪時々小雨",
	"thunder.png,雷",
	"thunder_rain.png,雷雨",
	"typhoon.png,台風",
	];

# お天気マークURL
$cf{weatherurl} = "./icon/weather";

# お天気マークの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{wico_max_img_w} = 94;
$cf{wico_max_img_h} = 60;
#-------------------------------------------------------------------------#

# -------------------------------------------------------------- #
# [ ココから「コメント返信」機能関連の設定 ]
#
# コメント返信機能ON/OFF
# → 0=no  1=yes
$cf{comment} = 1;

# コメント承認制 (0=no 1=yes)
# → 投稿記事を管理者が表示前に確認する場合（スパム対策）
$cf{approve} = 0;

# コメント書込CGIのURL【URLパス】
$cf{comment_cgi} = './comment.cgi';

# コメント返信採番ファイル【サーバパス】
$cf{resnum} = './data/resno.dat';

# TOP用採番ファイル【サーバパス】
$cf{rescnt} = './data/res_cnt.dat';

# コメント返信ログファイル名【サーバパス】
$cf{reslog} = './data/reslog.cgi';

# 最大コメント数 
# サンプルのため、少なく設定されているので、必ず修正する事！
$cf{max_res} = 5;

# アップロードディレクトリ【サーバパス】
$cf{r_upldir} = "./resupl";

# アップロードディレクトリ【URLパス】
$cf{r_uplurl} = "./resupl";

# コメント返信：画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{r_max_img_w} = 200;	# 横幅
$cf{r_max_img_h} = 120;	# 縦幅

# コメント検索１ページあたりの記事表示件数
$cf{max_resfind} = 5;

# コメント返信メール通知機能
# → 0=no  1=yes
$cf{res_mailing} = 1;

# メール通知先アドレス（メール通知する場合）
$cf{mailto_r} = 'xxx@xxxx.xxx';

# アイコン画像【URLパス】
# → [コメントアイコン]
$cf{ico_com} = "./cmn/icon/comment.png";

# コメント禁止ワードチェック
# → 投稿時禁止するワードをコンマで区切る
$cf{bad_word} = '';

# コメント日本語チェック（コメント内に日本語が含まれていなければ拒否）
# 0=no  1=yes
$cf{jp_word_chk} = 1;

# コメントアクセス制限（半角スペースで区切る、アスタリスク可）
# → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{bad_host} = '';

# コメント承認ログディレクトリ【サーバパス】
$cf{logdir} = './data/approve';

# サイドMENU内「コメントTOP(リンク数)」に掲載するタイトルリンクの数
$cf{max_com} = 10;

# -------------------------------------------------------------- #

# 管理者専用アイコン機能 (0=no 1=yes)
# (使い方) 記事投稿時に「管理者アイコン」を選択し暗証キーに「管理者専用アイコン用パスワード」を入力して下さい。
$cf{my_icon} = 0;

# 管理者専用アイコンの「ファイル名」を指定
$cf{my_gif}  = 'admin.gif';

# 管理者専用アイコン用パスワード
$cf{password} = '0123';
#-------------------------------------------------------------------------#

# 週表示
$cf{week} = ['日','月','火','水','木','金','土'];

# 書き込み案内アイコン（カレンダ上に表示されるアイコン）
$cf{guidance_icon} = 'aqua.gif';

# カレンダーの色指定
# → 順に、日～土、祝日、本日
$cf{week_col} = [
	'red',
	'gray',
	'gray',
	'gray',
	'gray',
	'gray',
	'blue',
	'#e29399',
	'#e5f2ff',
	];

# １ページ当たりの記事表示数 (親記事)
# カレンダー月次表示
$cf{mon_max} = 5;

# サイドMENU内「最新記事TOP(リンク数)」に掲載するタイトルリンクの数
$cf{max_topics} = 7;

# サイドMENU内「月別アーカイブ」に掲載する月数
$cf{max_archive} = 10;

# 最大記事数 (親記事+レス記事も含めた数）
$cf{max} = 50;

# 返信がつくと親記事をトップへ移動 (0=no 1=yes)
$cf{topsort} = 0;

# 画像の位置
# 1 : コメントの下
# 2 : コメントの左（廻り込み）
$cf{image_position} = 2;

# YouTubeを表示する
$cf{tube} = 1;

# Youtubeアイコン
$cf{tube_ico} = "./cmn/tube_icon.png";

# YouTube表示サイズ（max-size）
$cf{tubesize} = "640.5px";

# ミニカウンタの設置
# → 0=no 1=テキスト 2=GIF画像
$cf{counter} = 1;

# ミニカウンタの桁数
$cf{mini_fig} = 6;

# テキストのとき：ミニカウンタの色
$cf{cntcol} = "#fff";

# GIFカウンタのとき：画像までのディレクトリ
$cf{gif_path} = "./cmn";

# カウンタファイル
$cf{cntfile} = './data/count.dat';

# 本体CGIのURL【URLパス】
$cf{bbs_cgi} = './smart.cgi';

# 書込CGIのURL【URLパス】
$cf{post_cgi} = './post.cgi';

# 管理CGIのURL【URLパス】
$cf{admin_cgi} = './admin.cgi';

# 認証管理プログラム【サーバパス】
$cf{session_pl} = './lib/session.pl';

# 会員ファイル【サーバパス】
$cf{memfile} = './data/memdata.cgi';

# ログファイル【サーバパス】
$cf{logfile} = './data/log.cgi';

# アップロードディレクトリ【サーバパス】
$cf{imgdir} = './img';

# アップロードディレクトリ【URLパス】
$cf{imgurl} = "./img";

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = './tmpl';

# セッションディレクトリ【サーバパス】
$cf{sesdir} = './ses';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# jsファイルディレクトリ【サーバパス】
$cf{jsurl} = './cmn/js';

# ツールディレクトリ【サーバパス】
$cf{toolurl} = './cmn/tool';

# 戻り先のURL【URLパス】
$cf{homepage} = "../index.html";

# 記事にNEWマークを付ける時間（時間単位）
$cf{new_time} = 24;

# NEWマークの表示形態
#  → テキスト表示の場合には $cf{new_mark} = '<font color="#e29399">new!!!</font>';
$cf{new_mark} = '<img src="./cmn/new.png" alt="New Mark" title="New Mark">';

# Head表示用NEWマークの表示形態
#  → テキスト表示の場合には $cf{new_mark} = '<font color="#e29399">new!!!</font>';
$cf{head_new_mark} = '<img src="./cmn/new24.png" alt="New Mark" title="New Mark" class="icon">';

# 記事 [タイトル] 部の長さ (全角文字換算)
$cf{sub_len} = 40;

# 同一IPアドレスからの連続投稿時間（秒数）
# → 値を 0 にするとこの機能は無効になります
$cf{wait} = 60;

# １画面当たりの記事表示数 (親記事基準)
# → 順に、スレッド表示、アルバム表示、登録アイコン
$cf{max_thread} = 5;
$cf{max_albums} = 10;
$cf{max_icon} = 6;

# 返信数の制限
$cf{res_limit} = 10;

# メール通知機能
# → 0=no  1=yes
$cf{mailing} = 0;

# メール通知先アドレス（メール通知する場合）
$cf{mailto} = 'xxx@xxx.xxx';

# sendmailのパス（メール通知する場合）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# 文字色の設定（半角スペースで区切る）
$cf{colors} = '#000000 #666666 #98605e #ea5550 #da81b2 #f39800 #79c06e #387d39 #a688bd #8d93c8 #008db7';

# 旗色の設定（半角スペースで区切る）
$cf{colors_b} = '#a4a8d4 #3e62ad #2ca9e1 #003f8e #008db7 #a4d5bd #79c06e #9fc24d #417038 #5f6527 #24140e #736d71 #c9caca #e3acae #f3a68c #da81b2 #e95464 #ea5550 #ef857d #98605e #7b5544 #6a1917 #841a75 #941f57 #6c2463 #47266e #a688bd #ee7800 #e5a323 #f39800';
$cf{colors_b2}= 'ブルーラベンダー 杜若色 天色 インクブルー セルリアンブルー スプレイグリーン スペアミント リーフグリーン スピナッチグリーン オリーブグリーン ランプブラック スチールグレイ シルバー ピンクアーモンド サーモンピンク オーキッドピンク ローズ レッド コーラルレッド ココアブラウン コーヒー マルーン ラズベリー クラレット プラム ディープロイヤルパープル ラベンダーモーブ オレンジ パンプキン マリーゴールド';

# URLの自動リンク (0=no 1=yes)
$cf{auto_link} = 1;

# アイコンURL
$cf{iconurl} = "./icon";

# アイコン画像【URLパス】
# → 順に [eメール] [ホームページ]
$cf{ico_mail} = "./icon/mail.png";
$cf{ico_home} = "./icon/house.png";
$cf{ico_clip} = "./icon/clip.gif";
$cf{ico_edit} = "./icon/Edit.png";
$cf{ico_reply} = "./icon/reply.png";
$cf{ico_reply_diary} = "./icon/add.png";
$cf{ico_com_soon} = "./img/soon.gif";

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 1;

# アクセス制限（半角スペースで区切る、アスタリスク可）
#  → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
#  → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '111.99.13.190';

# 禁止ワード
# → 投稿時禁止するワードをコンマで区切る
$cf{no_wd} = '';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
$cf{jp_wd} = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 2;

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_text}  = 0;  # TEXT
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_excel} = 1;  # EXCEL
$cf{ok_word}  = 1;  # WORD
$cf{ok_ppt}   = 0;  # POWER POINT
$cf{ok_zip}   = 1;  # ZIP
$cf{ok_pdf}   = 1;  # PDF
$cf{ok_mp3}   = 1;  # MP3
$cf{ok_png}   = 1;  # PNG
$cf{ok_mp4}   = 1;  # MP4

# アイコン定義
# → 拡張子とファイル名のペア
$cf{icons} = {
	'.pdf'  => 'pdf.png',
	'.doc'  => 'word.png',
	'.docx' => 'Word-icon.png',
	'.xls'  => 'excel.png',
	'.xlsx' => 'Excel-icon.png',
	'.ppt'  => 'ppt.png',
	'.pptx' => 'powerpoint.png',
	'.txt'  => 'text.png',
	'.zip'  => 'zip.png',
	'.mp3'  => 'mp3.png',
	'.mp4'  => 'mp4.png',
};

# 添付ファイルアイコンディレクトリ【URLパス】
$cf{atturl} = './cmn/icon';

# 投稿受理最大サイズ (bytes)
# → 例 : 102400 = 100KB
$cf{maxdata} = 30720000;

# 画像ファイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 250;
$cf{max_img_h} = 150;

# アルバムサムネイルの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{alb_img_w} = 180;
$cf{alb_img_h} = 108;

# クッキーID名（特に変更しなくてよい）
$cf{cookie_id} = "joyfulbbs";

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードセッションディレクトリ
$cf{adminsesdir} = './data/session';

# -------------------------------------------------------------- #
# [ 以下は「過去ログ」機能を使用する場合の設定 ]
#
# 過去ログ生成
# ver 6.0より標準仕様となったためオリジナルでは廃止されている
# → 0=no 1=yes
$cf{pastkey} = 1;

# 過去ログ用NOファイル【サーバパス】
$cf{nofile}  = './data/pastno.dat';

# 過去ログのディレクトリ【サーバパス】
# → パスの最後に / をつけない
$cf{pastdir} = './data/past';

# 過去ログ１ファイルの行数
# → この行数を超えると次ページを自動生成します
$cf{pastmax} = 600;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 2;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captjoyfulbbs';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "ransom.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "dejavusans.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# アイコン追加
push(@{$cf{icon}},"$cf{my_gif},管理者用") if ($cf{my_icon});

# 設定内容を返す
sub set_init { return %cf; }

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if (!/^upfile\d+$/) {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行変換
			$val =~ s|\r\n|<br />|g;
			$val =~ s|[\n\r]|<br />|g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  コメント返信フォームデコード
#-----------------------------------------------------------
sub parse_form_com {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if ($_ ne 'upfile') {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行処理
			$val =~ s|\r\n|<br />|g;
			$val =~ s|[\r\n]|<br />|g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  フォームデコード(アイコン登録)
#-----------------------------------------------------------
sub parse_form02 {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if ($_ ne 'upfile') {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/'/&#39;/g;

			# 改行変換
			$val =~ s|\r\n|<br />|g;
			$val =~ s|[\n\r]|<br />|g;
		}

		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/smart.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/smart-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッター
	footer();
	exit;
}

#-----------------------------------------------------------
#  ユーザー登録アイコン画像リサイズ
#-----------------------------------------------------------
sub ico_resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{ico_max_img_w} || $h > $cf{ico_max_img_h}) {
		my $w2 = $cf{ico_max_img_w} / $w;
		my $h2 = $cf{ico_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

#-----------------------------------------------------------
#  コメント返信：画像リサイズ
#-----------------------------------------------------------
sub resize_res {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{r_max_img_w} || $h > $cf{r_max_img_h}) {
		my $w2 = $cf{r_max_img_w} / $w;
		my $h2 = $cf{r_max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  アルバム画像リサイズ
#-----------------------------------------------------------
sub alb_resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{alb_img_w} || $h > $cf{alb_img_h}) {
		my $w2 = $cf{alb_img_w} / $w;
		my $h2 = $cf{alb_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

#-----------------------------------------------------------
#  画像リサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}
	return ($w,$h);
}

#-----------------------------------------------------------
#  diaryモード切り替えパスワード制限
#-----------------------------------------------------------
sub passwd3 {
	my %in = @_;

	# パスワードが未入力の場合は入力フォーム画面
	if ($in{pass} eq "") {
		change_form();

	# パスワード認証
	} elsif ($in{pass} ne $cf{mode_pass}) {
		error("認証できません");
	}
}

#-----------------------------------------------------------
#  diaryモード切り替えパスワード入力フォーム
#-----------------------------------------------------------
sub change_form {

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/change_pass.html") or error("open err: change_pass.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/smart.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/smart-mobile.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	footer();
	exit;

}

#-----------------------------------------------------------
#  diary管理モードパスワード制限
#-----------------------------------------------------------
sub passwd2 {
	my %in = @_;

	# パスワードが未入力の場合は入力フォーム画面
	if ($in{pass} eq "") {
		post_form();

	# パスワード認証
	} elsif ($in{pass} ne $cf{diary_pass}) {
		error("認証できません");
	}
}

#-----------------------------------------------------------
#  diary管理モードパスワード入力フォーム
#-----------------------------------------------------------
sub post_form {

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/pass_form.html") or error("open err: pass_form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/smart.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/smart-mobile.css|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	footer();
	exit;

}

#-----------------------------------------------------------
#  月の末日
#-----------------------------------------------------------
sub last_day {
	my ($yy,$mm) = @_;
	
	return (31,28,31,30,31,30,31,31,30,31,30,31) [$mm - 1]
		+ ($mm == 2 && (($yy % 4 == 0 && $yy % 100 != 0) || $yy % 400 == 0));
}

#-----------------------------------------------------------
#  週算出
#-----------------------------------------------------------
sub get_week {
	my ($yy,$mm,$dd) = @_;
	
	if ($mm == 1 || $mm == 2) {
		$yy--;
		$mm += 12;
	}
	int( $yy + int($yy / 4) - int($yy / 100) + int($yy / 400) + int((13 * $mm + 8) / 5) + $dd ) % 7;
}

1;

